
// var_dump_cache: holds content of objects and arrays, to unique endless recursion
var var_dump_cache = {};
function var_dump(obj, br, indentation, recursionLevel) {
	var str = '';
    if (!br) {
		br = '\n';
	}
    if (!indentation) {
		indentation = '';
	}
	if (recursionLevel==undefined) {
		recursionLevel = 0;
		var_dump_cache = {};
	} else {
		recursionLevel += 1;
	}
	
	var property, pvalue, type, objectType;
	//For some reason people hate me for doing this sort of code, bad practice ?
	//Anyway, loop over all the properties and append them to a string.
	try {
		for (property in obj) {
			pvalue = null;
			try {
				pvalue = obj[property];
			} catch (ex) {
				pvalue = '[INACCESSIBLE]';
			}
			if (pvalue != null) {
				type = typeof(pvalue);
				if (type == 'object') {
					// get name of the object from toString representation
					objectType = "" + pvalue;
					objectType = objectType.match(/\[object\s+([\w_][\w\d_]*)/);
					if (objectType && objectType.length && objectType.length==2) {
						objectType = objectType[1];
					} else {
						objectType = 'Unknown';
					}
					if (var_dump_cache[objectType] != undefined) {
						str += indentation + property + ': ' + var_dump_cache[type] + '\n';
					} else {
						var_dump_cache[objectType] = 'Object already dumped';
						//alert(property +', ' + type + ', ' + var_dump_cache[type] + ', ' + objectType);
						innerObject = var_dump(pvalue, br, indentation + '    ', recursionLevel);
						if (innerObject != '') {
							str += indentation + property + ': {\n' + innerObject + '\n' + indentation + '}\n';
						} else {
							str += indentation + property + ': {}\n';
						}
					}
				} else if (type == "function") {
					str += indentation + property + ' (' + typeof(pvalue) + ') : {...}' + br;
				} else {
					str += indentation + property + ' (' + typeof(pvalue) + ') : ' + pvalue + br;
				}
			} else {
				str += indentation + property + ' : null' + br;
			}
		}
	} catch (ex) {
		str += indentation + property + ' : Exception occured: ' + ex + br;
	}
	recursionLevel--;
	return str;
}
