var datagrid = null;

function move() {
	var x = document.getElementById('x').value;
	var y = document.getElementById('y').value;
	if (!x || !y || !datagrid) { return }
	
	if (x < 0 || x >= datagrid.getColumnCount()) {
		alert('x out of bounds');
	}
	if (y < 0 || y >= datagrid.getRowCount()) {
		alert('y out of bounds');
	}
	
	datagrid.setActiveCell(x,y);
}

window.addEvent("domready", function(){
	var columnCount = Math.ceil(15+Math.random()*20);
	var rowCount = Math.ceil(20+Math.random()*100);
	var cmu = new Array();
	
	for (var i = 0; i < columnCount; i++) {
		cmu.push(
					{
					   header: "Column #" + i,
					   dataIndex: 'column_' + i,
					   dataType:'string',
					   editable:true,
					   width:100
					}
		);
	}
	
	var data = {"page":1,"total":18,"data":null}
	data['data'] = new Array();
	for (var i = 0; i < rowCount; i++) {
		var item = {};
		for (var j = 0; j < columnCount; j++) {
			item['column_' + j] = 'Data_' + j + 'x' + i;
		}
		data['data'].push(item);
	}
	
	$('gx').set('text', columnCount);
	$('gy').set('text', rowCount);
	
	datagrid = new ActiveGrid('grid', {
		width:800,
		height: 400,
		columnModel: cmu,
		buttons : null,
		url: null,
		pagination:false,
		serverSort:false,
		showHeader: true,
		alternaterows: true,
		sortHeader:false,
		resizeColumns:true,
		multipleSelection:false,
		editable: true
	});
	datagrid.setData(data);
 });
