var datagrid = null;
var cmu = null;


function setrow() {
	var rownumber = parseInt(document.getElementById('rownumber').value);
	if (isNaN(rownumber) || rownumber < 0 || rownumber >= datagrid.getRowCount()) {
		alert('rownumber improper or out of bounds');
		return;
	}
	
	var row = {};
	for (c = 0; c < cmu.length; c++) {
		row[cmu[c].dataIndex] = $(cmu[c].dataIndex).get('value');
	}
	datagrid.setDataByRow(rownumber, row);
}

function getrow() {
	var rownumber = parseInt(document.getElementById('rownumber').value);
	if (isNaN(rownumber) || rownumber < 0 || rownumber >= datagrid.getRowCount()) {
		alert('rownumber improper or out of bounds');
		return;
	}
	
	var row = datagrid.getDataByRow(rownumber);
	$('content').set('html', '<div>Note: Data type below is javascript type, not column one</div>' + var_dump(row, '<br/>'));
	for (dataIndex in row) {
		$(dataIndex).set('value', row[dataIndex]);
	}
}


function initsetform(cmu) {
	var formDiv = $('setform');
	for (var c = 0; c < cmu.length; c++) {
		var rowDiv = new Element('span');
		var label = new Element('label', {html: c + '&nbsp;'});
		var input = new Element('input', {type: 'text', id:cmu[c].dataIndex});
		input.setStyle('width', 75);
		rowDiv.appendChild(label);
		rowDiv.appendChild(input);
		rowDiv.appendChild(new Element('span', {html:'&nbsp;'}));
		formDiv.appendChild(rowDiv);
	}
	formDiv.appendChild(new Element('input', {type:'button', value: 'set', onclick:'setrow()'}).setStyle('width', 75));
}

window.addEvent("domready", function(){
	cmu = [
		{
			header: "String",
			dataIndex: 'column_1',
			dataType:'string',
			editable:true,
			width:100
		},
		{
			header: "Integer",
			dataIndex: 'column_2',
			dataType:'integer',
			editable:true,
			width:60
		},
		{
			header: "Number .02",
			dataIndex: 'column_3',
			dataType:'number',
			editable:true,
			width:100
		},
		{
			header: "Number .04",
			dataIndex: 'column_4',
			dataType:'number',
			decimalPlaces:4,
			editable:true,
			width:100
		},
		{
			header: "Chk",
			dataIndex: 'column_5',
			dataType:'checkbox',
			editable:true,
			width:100,
			labelT:'Yes',
			labelF:'No'
		},
		{
			header: "Chkd",
			dataIndex: 'column_6',
			dataType:'checkbox',
			editable:false,
			width:100
		},
		{
			header: "Boolean",
			dataIndex: 'column_7',
			dataType:'boolean',
			editable:true,
			width:100
		},
		{
			header: "Select",
			dataIndex: 'column_8',
			dataType:'select',
			options: ['option 1', 'option 2', 'option 3', 'option 4', 'option 5'],
			editable:true,
			width:100
		}
	];
	
	initsetform(cmu);
	var rowCount = 10;
	var rows = new Array();
	var d;
	for (i = 0; i < rowCount; i++) {
		d = new Array();
		d.push('Data ' + i + 'x' + rowCount);
		d.push(i);
		d.push(i + 0.01);
		d.push((i + 0.02).toFixed(4));
		d.push(Math.ceil(Math.random()*100)%2);
		d.push(Math.ceil(Math.random()*100)%2);
		d.push(Math.ceil(Math.random()*100)%2);
		d.push(cmu[7].options[Math.ceil(Math.random()*100)%5]);

		var item = new Object;
		for (var j = 0; j < cmu.length; j++) {
			item[cmu[j].dataIndex] = d[j];
		}
		rows.push(item);
	}
	
	var data = {"page":1,"total":10,"data":rows}
	
	datagrid = new ActiveGrid('grid', {
		width:500,
		height: 400,
		columnModel: cmu,
		buttons : null,
		withactivecell:true,
		url: null,
		pagination:false,
		serverSort:false,
		showHeader: true,
		alternaterows: true,
		sortHeader:false,
		resizeColumns:true,
		multipleSelection:false,
		editable: true
	}, data);
 });
